<?php
	$status = false;
  $roles = wp_roles()->get_names();
  if(isset($_POST['genesiv_submit_api_settings']) && $_POST['genesiv_submit_api_settings'] == 'Save Settings') {

    $genesiv_api_key = trim($_POST['genesiv_api_key']);
    $genesiv_api_hostname = trim($_POST['genesiv_api_hostname']);

    update_option('genesiv_api_key', $genesiv_api_key);
    update_option('genesiv_api_hostname', $genesiv_api_hostname);
    update_option('genesiv_roles_access_level', $_POST['role_access_level']);
    $status = true;
  }
?>
<div class="wrap">

  <?php if($status == true) { ?>
    <div class="notice notice-success"><p><b>Save Settings Successfully.</b></p></div>
  <?php } ?>

  <form method="post" id="wp-genesiv-api-settings" name="wp-genesiv-api-settings">
    <h1>Genesiv API Settings</h1>
    <table class="form-table" role="presentation">
      <tbody>
        <tr>
          <th scope="row"><label for="genesiv_api_key">API Key</label></th>
          <td><input name="genesiv_api_key" type="text" id="genesiv_api_key" class="regular-text" value="<?php echo get_option( 'genesiv_api_key' ); ?>" required="required"></td>
        </tr>
        <tr>
          <th scope="row"><label for="genesiv_api_hostname">API Hostname</label></th>
          <td><input name="genesiv_api_hostname" type="text" id="genesiv_api_hostname" class="regular-text" value="<?php echo get_option( 'genesiv_api_hostname' ); ?>" required="required"></td>
        </tr>
      </tbody>
    </table>

    <h1>Genesiv Roles Access Level</h1>
    <table class="form-table" role="presentation">
      <tbody>
        <?php if(!empty($roles)) { ?>
          <?php $genesiv_roles_access_level = get_option( 'genesiv_roles_access_level' ); ?>
          <?php foreach($roles as $rolekey => $role) { ?>
            <tr>
              <th scope="row"><label for="role_access_level_<?php echo $rolekey; ?>"><?php echo $role; ?> Access Level</label></th>
              <td>
                <input type="number" min="1" step="1" name="role_access_level[<?php echo $rolekey; ?>]" id="role_access_level_<?php echo $rolekey; ?>" class="regular-text" required="required" value="<?php if(!empty($genesiv_roles_access_level[$rolekey])) { echo $genesiv_roles_access_level[$rolekey]; } ?>">
              </td>
            </tr>
          <?php } ?>
        <?php } ?>
      </tbody>
    </table>

    <p class="submit">
      <input type="submit" name="genesiv_submit_api_settings" id="genesiv_submit_api_settings" class="button button-primary" value="Save Settings">
    </p>
  </form>
</div> 
