<?php
/*
Plugin Name: WP Genesiv Sync Users
Version: 1.0
Description: This plugin is developed to sync wordpress users to app server.
Author: WP Coders
Author URI: http://wpcoders.in/
Text Domain: wpcoders
Domain Path: /languages/
License: GNU General Public License v3.0
License URI: http://www.gnu.org/licenses/gpl-3.0.html
*/

add_action("admin_menu", "wp_genesiv_options_submenu");
function wp_genesiv_options_submenu() {
  add_submenu_page('options-general.php', 'Genesiv API Settings', 'Genesiv API Settings', 'manage_options', 'genesiv-api-settings', 'wp_genesiv_api_settings_page' );
}

function wp_genesiv_api_settings_page() {
  include_once('wp-genesiv-api-settings.php');
}

add_shortcode( 'genesiv-login-link', 'genesiv_app_login_button_link_function' );
function genesiv_app_login_button_link_function( $atts, $content = "" ) {

  $serverLoginUrl = "#";
  $api_key = get_option( 'genesiv_api_key' );
  $api_hostname = get_option( 'genesiv_api_hostname' );
  $genesiv_roles_access_level = get_option( 'genesiv_roles_access_level' );
  if( is_user_logged_in() && get_current_user_id() && !empty($api_key) && !empty($api_hostname) && !empty($genesiv_roles_access_level)) {
    $current_user_id = get_current_user_id();
    $current_user_data = get_user_by("ID", $current_user_id);
    $current_user_role = current($current_user_data->roles);

    $user_login_Id = str_replace(" ", "-", $current_user_data->data->user_login);
    $user_access_level = $genesiv_roles_access_level[$current_user_role];
    $user_first_name = get_user_meta($current_user_data->data->ID, 'first_name', true);
    $user_last_name = get_user_meta($current_user_data->data->ID, 'last_name', true);
    $user_email_address = $current_user_data->data->user_email;
    $user_display_name = $current_user_data->data->display_name;

    $api_params = array(
      'userId' => $user_login_Id,
      'accessLevel' => $user_access_level,
      'action' => 'login',
      'firstname' => $user_first_name,
      'lastname' => $user_last_name,
      'email' => $user_email_address,
      'displayname' => $user_display_name
    );

    $api_params = array_filter($api_params);
    $api_query_params = http_build_query($api_params);
    $api_endpoint = "https://rajesh.genesiv.com/api/secureAuth?" . $api_query_params;

    $curl = curl_init();
    curl_setopt_array($curl, array(
      CURLOPT_URL => $api_endpoint,
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => '',
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 0,
      CURLOPT_FOLLOWLOCATION => true,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => 'GET',
      CURLOPT_HTTPHEADER => array(
        'apiKey: ' . $api_key,
        'hostname: ' . $api_hostname
      )
    ));

    $response = curl_exec($curl);
    $httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);

    curl_close($curl);
    $response_array = json_decode($response);

    if($httpCode == 200 && !empty($response_array->loginUrl)) {
      $serverLoginUrl = $response_array->loginUrl;
    }
  }

  $content .= $serverLoginUrl;
  return $content;
}
